clear

%Read data
%data = xlsread('Chile.xlsx');
%data=csv2mat_numeric('CHiIM_micro-data_2002.out');
load data;
rng('default');
%seed
rng(1);
datasize=length(data);
repetitions=1000;
sample_size=[50000,100000,250000,500000,1000000,2000000,5000000,10000000];% 1000 10000 100000]
%sample_size= [1000 10000 100000]
age_proportions_long = zeros(repetitions,108);
age_proportions_short = zeros(repetitions,108);

long_migration_col = 4;
short_migration_col= 3;
age_col = 1;

random_sample=zeros(sample_size(1),1);
long_age_counter=zeros(108,1);
%for s=1:length(sample_size),
 for k=1:length(sample_size),   
    %Repeat 1000 times
    
    current_size=sample_size(k)
    for i=1:repetitions,
        i
        %fOR each sample size, Select a random sample of size sample_size
        long_age_counter=zeros(108,1);
        shuffled = data(randperm(length(data(:,1))),:);
        
        random_sample=shuffled(1:sample_size(k),:);
       
            % random_sample=round(datasize*rand(sample_size(k),1));
            %for all the records in this random sample
            for j=1:sample_size(k),
              %  random_sample(j)=round(datasize*rand(1,1));
              %  while random_sample(j)==0,
                    
              %      random_sample(j)=round(datasize*rand(1,1));
              %  end
                
%                 if j==1,
%                     j=1;
%                 else
%                     match = find(random_sample(1:j-1) == random_sample(j));
%                     if isempty(match),
%                         match;
%                     else
%                         while ~isempty(match),
%                             random_sample(j)=round(datasize*rand(1,1));
%                             match = find(random_sample(1:j-1) == random_sample(j));
%                         end
%                     end
%                 end
                
                %             for x=1:sample_size(k),
                %                 if random_sample(x) ==  random_sample(j) && x~=j,
                %                     random_sample(x) = round(datasize*rand(1,1));
                %                 else if random_sample(x) ==0,
                %                         random_sample(x) = round(datasize*rand(1,1));
                %                     end
                %                 end
                %             end
                %check if they have moved long distance
                long_age_counter(random_sample(j,age_col)) = long_age_counter(random_sample(j,age_col)) + 1;
                if random_sample(j,long_migration_col) == 1,
                    %if yes, increase counting variable by 1
                    age_proportions_long(i,random_sample(j,age_col)) = age_proportions_long(i,random_sample(j,age_col)) + 1;
                end
                %check if they have moved long distance
                if random_sample(j,short_migration_col) == 1,
                    %if yes, increase counting variable by 1
                    age_proportions_short(i,random_sample(j,age_col)) = age_proportions_short(i,random_sample(j,age_col)) + 1;
                end
            end
            for age=5:108,
                age_proportions_long(i,age)=age_proportions_long(i,age)/long_age_counter(age);
                age_proportions_short(i,age)=age_proportions_short(i,age)/long_age_counter(age);
            end
            
            
            
        end
   
    
    filename1=strcat('long_distance',num2str(sample_size(k)),'.csv');
    filename2=strcat('short_distance',num2str(sample_size(k)),'.csv');
    
    csvwrite(filename1,age_proportions_long);
    csvwrite(filename2,age_proportions_short);
 end